# README for netconfd unit tests

## Overview

This directory contains unit tests for the netconfd repository.  The tests use the CppUTest framework which is also used in vyatta-dataplane and vyatta-controller.  The Makefile structure is copied from the latter, and allows for different sets of tests to be created via the different <test_suite_name>.mk files in this directory which are automatically pulled in to the build.  This means different sets of tests can have different flags, and different libraries, included in the build.

Note that CppUTest can work in C++ or C 'mode', and due to various header files that are imported here using 'new' as a parameter name, we need to use the C variant here.  This means we need the _wrapper.cpp files to pull in the C code, and we need to explicitly list out each test.

## Building Unit Tests

While netconfd is fairly quick to build in its entirety, and this does build the unit tests, it is much faster to be able to just build the unit tests, and if you use 'entr' you can have the tests run every time you save code changes.  The following process is likely not the only / best way to do this, but it does appear to work ...

(a) Setup a chroot (optional)

(b) Run initial build (optional)

This is not needed to be able to run the unit tests as nothing is generated by this step that is needed.  However, this is what you would do:

> cd work/netconfd
> dpkg-buildpackage -us -uc

(c) Make unit tests

(In chroot) From netconfd repo root directory (work/netconfd):

> make check

(d) Edit code

(e) TDD-style rebuild of UT

For this you need to install 'entr' (into the chroot):

> sudo apt-get install entr

> find . -name "*.[ch]" | entr make check

(This won't pick up changes to the cpp wrapper file(s), nor .mk, as I can't quite work out the full pattern for this, but it's fairly effective when you're just editing .c / .h files.)

